
clear all;
clc;

%loading path
tem_fd = cd;
par.d_fd          =   [cd '/database/'];
addpath([cd '/utilities/']);
addpath([cd '/RUNTIME/']);

%loading data
load([par.d_fd 'AR_database']);
Tr_DAT = Tr_dataMatrix; trls = Tr_sampleLabels;
Tt_DAT = Tt_dataMatrix; ttls = Tt_sampleLabels;
clear Tr_dataMatrix Tt_dataMatrix Tr_sampleLabels Tt_sampleLabels;

%downsample data
for i = 1:size(Tr_DAT,2)
    tem = reshape(Tr_DAT(:,i),[165 120]);
    tem1 = uint8(imresize(tem,[33 24]));
    O_Tr_DAT(:,i) = tem1(:);
end

Tem_DAT = [];
for i = 1:size(Tt_DAT,2)
    tem = reshape(Tt_DAT(:,i),[165 120]);
    tem1 = uint8(imresize(tem,[33 24]));
    O_Tt_DAT(:,i) = tem1(:);
end

O_Tr_DAT = double(O_Tr_DAT);
O_Tt_DAT = double(O_Tt_DAT);

D          =  O_Tr_DAT;
D          =   D./ repmat(sqrt(sum(D.*D)),[size(D,1) 1]);
D_labels   =   trls;
clear O_Tr_DAT;
classnum   =  100;
dimension  =  size(D,1);


method = 'RCl2'; lambda = 1e-3; median_c = 0.8; beta_c = 8; mean_x = mean(D,2);maxI= 3;weight_thre=1e-2;
% method = 'RCl1'; lambda = 1e-3; median_c = 0.8; beta_c = 8; mean_x = mean(D,2);maxI= 3;weight_thre=1e-2;

proce_num = 700; O_Tt_DAT  = O_Tt_DAT(:,1:proce_num); ttls      = ttls(1:proce_num);
ID  =  [];
total_time = 0;
for indTest = 1:size(O_Tt_DAT,2)
    fprintf(['Totalnum:' num2str(size(O_Tt_DAT,2)) 'Nowprocess:' num2str(indTest) '\n']);
    tic;

    %RCL2
    [id] = RCL2_RUNTIME(O_Tt_DAT,D,D_labels,classnum,indTest,lambda,median_c,beta_c,mean_x,maxI,weight_thre);

    %RCL1 faster when feature dimension is less than number of dictionary
    %atoms.
%     [id] = Rl1C_RUNTIME1(O_Tt_DAT,D,D_labels,classnum,indTest,lambda,median_c,beta_c,mean_x,maxI,weight_thre); 

    %RCL1 faster when number of dictionary atoms is less than feature
    %dimension.
%     [id] = Rl1C_RUNTIME(O_Tt_DAT,D,D_labels,classnum,indTest,lambda,median_c,beta_c,mean_x,maxI,weight_thre); 

    total_time = total_time + toc;
    ID(indTest) = id;
end

reco_rate = sum(ID==ttls)/length(ttls);
fid = fopen([cd 'AR_RUNTIME.txt'],'a');
fprintf(fid,'\n\n%s%s',' Method: ',method);
fprintf(fid,'%s%f', ' Dim: ',dimension);
fprintf(fid,'%s%f', ' ATime: ',total_time/length(ttls));
fprintf(fid,'%s%f%s%f', ' Reco_rate: ',reco_rate, '  Proc_num: ',proce_num);
fclose(fid);

